/**
 *  B L I N K
 * --------------------------------------------------------------------------
 *
 *    The Blink program is a simple Mica2 application that simply turns the
 * LED on and off once per second. It configures the Timer0 device to
 * interrupt the processor twice per second and uses the interrupt routine
 * to toggle the red LED.
 *
 */

program blink {

    components { BlinkMain, Mica2 }

    entrypoint main = BlinkMain.entry;
    entrypoint timer0_comp = Timer0.compareHandler;
}

component BlinkMain {

    constructor() {
        Mica2.setTimerCompare(Mica2.red.toggle); // set the function to call on overflow
    }

    method entry() {
	    Mica2.setPorts();
        Mica2.startTimer();           // start up the basic timer
        while ( true ) Mica2.sleep(); // sleep until and after every interrupt
    }
}
