/**
 *  C N T T O L E D S
 * --------------------------------------------------------------------------
 *
 *
 */

program CntToLeds {

    components { Main, Mica2 }

    entrypoint main = Main.entry;
    entrypoint timer0_comp = Timer0.compareHandler;
//    entrypoint timer0_overflow = Timer0.overflowHandler;
}

component Main {

    field count: int;

    constructor() {
        Mica2.setTimerCompare(increment); // set the function to call on overflow
    }

    method entry() {
	Mica2.setPorts();
        Mica2.startTimer();           // start up the basic timer
        while ( true ) Mica2.sleep(); // sleep until and after every interrupt
    }

    method increment() {
        count++;
        on(Mica2.red, 0);
        on(Mica2.green, 1);
        on(Mica2.yellow, 2);
    }

    method on(l: LED, b: int) {
        local bits = count :: 3;
        if ( bits[b] != 0b0 ) l.on();
        else l.off();
    }
}
