class A {
   field f: int = 4;
   method m(): int { return f; }
}

class B extends A {
   field g: int = 5;
   method m(): int { return f + g; }
   method n(): int { return g; }
}


component heap {
    field array: int[] = { 4, 5, 9, 7, 9, 1, 0 };
    field a: A = new A();
    field b: B = new B();
    field m: function():int = b.m;
    field n: function(A, B):int = foo;
    field r: A[] = { a, b };
    field rr: A[][] = { r };

    field f: A?;
    field g: A?[];
    field h: A[]?;
    field i: function(A?): B?;
    field j: function(G): G?;

    method cast<T>(o: T?): T { 
        if ( o == null ) throw NullAccess; 
        else return o; 
    }

    field kn: function<T>(T*): T; // zero or more T
    field ko: function<T>(T): T;  // exactly one T
    field kp: function<T>(T+): T; // one or more T

    constructor() {
        sort(array);
    }

    type tuple<T...> { }

    type function<T...,T> { }

    type object {
        operator .<T object, m in T.methods>(o: T): m.type [written o.m] { ... }
        operator .<T object, f in T.fields>(o: T): f.type [written o.f] { ... }
        operator .<T object, f in T.fields> = (o: T, e: f.type): f.type [written o.f = e] { ... }
    }

    qualifier pos for x: int {
        pos x <=> x > 0;
        pos x and pos y => pos {x + y}
        pos x and pos y => pos {x * y}
    }

    qualifier nonzero for x: int {
        nonzero x <=> x != 0;
        nonzero x for {e/x} => safe;
    }

    qualifier nonnull for x: class T {
        true => nonnull {new T(*)}
        nonnull x <=> x != null;
        nonnull x => safe {x.f};
        nonnull x => safe {x.m};
        nonnull x => safe {x.f = e};
        nonnull x => safe {x.length};
    }

    qualifier inbounds for x: array<T>, i: int {
        inbounds x,i <=> pos i and i < x.length; 
        nonnull x and inbounds x,i => safe {x[i]};
        nonnull x and inbounds x,i => safe {x[i] = e};
    }

    type complex: (double, double) {
        operator +(a: complex, b: complex): complex {
            return (a.0 + b.0, a.1 + b.1);
        }
        operator *(a: complex, b: complex): complex {
            return (a.0 * b.0 - a.1 * b.1, a.0 * b.1 + a.1 * b.0);
        }
        operator /(a: complex, b: complex): complex {
            return a * inv(b);
        }
        method inv(a: complex): complex {
            
        }
        operator auto(a: int): complex {
            return (a::double, 0.0);
        }
        operator auto(a: double): complex {
            return (a, 0.0);
        }
    }

    method sort<T>(a: T[], gt: function(T, T): boolean) {
        local i: int, j: int, len = a.length;
        for ( i = 0; i < len; i++ ) {
            for ( j = i+1; j < len; j++ ) {
                if ( gt(a[i], a[j]) ) {
                   local t = a[i];
                   a[i] = a[j];
                   a[j] = t;
                }
            }
        }
    }

    method foo(aa: A, bb: B): int {
	return 0;
    }
}
