component ADC {

   field ADEN: 8 = 0x80;
   field ADSC: 8 = 0x40;
   field ADFR: 8 = 0x20;
   field ADIF: 8 = 0x10;
   field ADIE: 8 = 0x08;
   field ADPS2: 8 = 0x04;
   field ADPS1: 8 = 0x02;
   field ADPS0: 8 = 0x01;

   field ADC0: 3 = 00;
   field ADC1: 3 = 01;
   field ADC2: 3 = 02;
   field ADC3: 3 = 03;
   field ADC4: 3 = 04;
   field ADC5: 3 = 05;
   field ADC6: 3 = 06;
   field ADC7: 3 = 07;

   field convFunc: function(10) = none;

   method enable() {
      // enable ADC by setting ADEN bit
      device.ADCSRA = device.ADCSRA | ADEN;
	//device.ADCSRA = device.ADCSRA | ADFR;
	device.ADCSRA = device.ADCSRA | ADIE;
	device.ADMUX = 0x0;
   }

   method disable() {
      // disable ADC by clearing ADEN bit
      device.ADCSRA = device.ADCSRA & ~ADEN;
   }

   method startConv(channel: 3, freeRunning: boolean) {
	// start ADC conversion
      //if ( freeRunning == true ) {
      //   adcsra = adcsra | ADFR;
      //}
      device.ADMUX = channel;
	//device.ADCSRA = device.ADCSRA | ADIE;
      device.ADCSRA = device.ADCSRA | ADSC;
   }

   method setConvFunc(f: function(10)) {
      convFunc = f;
   }

   method convHandler() {
      local low: 8 = device.ADCL;
      local high: 8 = device.ADCH;
      //local value: 10 = (high << 8) | low;
      local value: 10 = high;
	convFunc(value);
   }

   method none(value: 10) { }
}
