component Mica2 {

    field portA: PortA = new PortA();
    field portB: PortB = new PortB();
    field portC: PortC = new PortC();
    field portD: PortD = new PortD();
    field portE: PortE = new PortE();

    field green: LED  = new LED(new Pin(portA, 1), "Green");
    field yellow: LED = new LED(new Pin(portA, 0), "Yellow");
    field red: LED    = new LED(new Pin(portA, 2), "Red");

    method startTimer() {
	device.ASSR = 0b1000;        // set Timer0 to asynch operation
	Timer0.setMode(Timer0.MODE_CTC);
        Timer0.setCompareMatch(16);         // compare matches every (16 * 1024) cycles
        Timer0.setCount(0);                 // reset the count
        device.TIMSK = 0b10;                // enable the Timer0 compare interrupt
        Timer0.setDivider(Timer0.DIV_1024); // set divider to 1024
    }

    method setTimerCompare(cf: function()) {
        Timer0.setCompare(cf);
    }

    method sleep() {
	device.SREG = (0b10000000); // enable interrupts
        device.MCUCR = 0x00;
        // device.sleep();
    }

    method setPorts() {
	portA.setOutput();
	portA.out(0xff);
	portC.setOutput();
	portE.setOutput();
    }

    method startLightSensor() {
	portE.out(0b00100000);
    }
}

