class Pin {
    field port: Port;
    field mask: 8;

    constructor(p: Port, b: int) {
        port = p;
        mask = 0b00000001 << b;
    }
    method in(): boolean { return (port.in() & mask) != 0; }
    method out(b: boolean) {
	local v = port.in();
	port.out(b ? v | mask : v & ~mask);
    }
}

class Port {
    method out(v: 8);
    method in(): 8;
    method setOutput() { setDirection(0xff); }
    method setInput() { setDirection(0x00); }
    method setDirection(dir: 8);
}

class PortA extends Port {
    method out(v: 8) { device.PORTA = v; }
    method in(): 8 { return device.PINA; }
    method setDirection(dir: 8) { device.DDRA = dir; }
}

class PortB extends Port {
    method out(v: 8) { device.PORTB = v; }
    method in(): 8 { return device.PINB; }
    method setDirection(dir: 8) { device.DDRB = dir; }
}

class PortC extends Port {
    method out(v: 8) { device.PORTC = v; }
    method in(): 8 { return device.PINC; }
    method setDirection(dir: 8) { device.DDRC = dir; }
}

class PortD extends Port {
    method out(v: 8) { device.PORTD = v; }
    method in(): 8 { return device.PIND; }
    method setDirection(dir: 8) { device.DDRD = dir; }
}

class PortE extends Port {
    method out(v: 8) { device.PORTE = v; }
    method in(): 8 { return device.PINE; }
    method setDirection(dir: 8) { device.DDRE = dir; }
}
