component Radio {
    field recvPos: int;
    field recvBuf: byte[];
    field recvCallback: function(byte[], int);

    field sendBuf: byte[];
    field sendLength: int;
    field sendPos: int;
    field sendCallback: function(byte[], boolean);


    method send(buf: byte[], len: int, cbf: function(byte[], boolean)) {
	if ( sendBuf == null ) {
	    sendBuf = buf;
	    sendCallback = cbf;
	    sendLength = len;
	    sendPos = 0;
	    startTransmit();
	}
    }

    private method startTransmit() {
	// send mode change to CC1000
	// set up SPI interrupt to deliver data
    }

    private method recvByte(b: byte) {
	if ( recvBuf == null ) return;
	if ( b == 0 ) finishRecv();
	else if ( recvPos >= recvBuf.length ) finishRecv();
	else recvBuf[recvPos++] = b;
    }

    private method finishRecv() {
	recvCallback(recvBuf, recvPos);
	recvBuf = acquireNewBuf();
	recvPos = 0;
    }
}

class Packet {
    field dest: int;
    field length: int;
    field data: byte[] = new byte[22];

    field notifyOnSend: function(Packet, boolean);

    method setByte(ind: int, b: byte) {
	data[ind + 6] = b;
    }

    method getByte(ind: int): byte {
	return data[ind + 6];
    }

    method encode(sourceAddress: int) {
	data[0] = length;
	data[1] = length >> 8;
	data[2] = dest;
	data[3] = dest >> 8;
	data[4] = sourceAddress;
	data[5] = sourceAddress >> 8;
    }

    private method callback(buf: byte[], b: boolean) {
	if ( notifyOnSend != null ) notifyOnSend(this, b);
	packetPool.release(this);
    }
}