program List {
    components { Main }
    entrypoint main = Main.entry;
}

component Main {

    field list: LinkedList;

    constructor() {
        list = new LinkedList();
        list.add(new Data(0));
        list.add(new Data(1));
        list.add(new Data(2));
        list.add(new Data(3));
        list.add(new Data(4));
        list.add(new Data(5));
        list.add(new Data(6));
        list.add(new Data(7));
        list.add(new Data(8));
        list.add(new Data(9));
        list.add(new Data(10));
        list.add(new Data(11));
        list.add(new Data(12));
    }

    method entry() {
	list.apply(print);
    }

    method print(d: Data) {
	// do nothing
    }
}

class LinkedList {
    field head: Link;
    field tail: Link;

    method add(d: Data) {
        if ( head == null ) {
            head = tail = new Link(d);
        } else {
            local next = new Link(d);
            tail.next = next;
            next.prev = tail;
	    tail = tail.next;
        }
    }

    method apply(f: function(Data)) {
        local pos = head;
        while ( pos != null ) {
            f(pos.data);
            pos = pos.next;
        }
    }

    method applyRev(f: function(Data)) {
        local pos = tail;
        while ( pos != null ) {
            f(pos.data);
            pos = pos.prev;
        }
    }
}

class Link {
    field data: Data;
    field next: Link;
    field prev: Link;

    constructor(d: Data) {
        data = d;
    }

    method insert(d: Data) {
        local next = new Link(d);
        next.next = this.next;
        this.next.prev = next;
        this.next = next;
    }
}

class Data {
    field val: int;
    constructor(i: int) {
        val = i;
    }
}