// @Harness: tir-init
// @Test: static method invocations
// @HeapGC: false
// @Result: PASS

component fold02 {
    field a: int;
    field b: int;

    constructor() {
        local array = new int[1000];
	a = fold(add, array, array.length - 1);
        b = fold(mult, array, array.length - 1);
    }

    method add(a: int, b: int): int {
	return a + b;
    }

    method mult(a: int, b: int): int {
        return a * b;
    }

    // iterative version of fold
    method fold(f: function(int, int): int, a: int[], m: int): int {
	return m == 0 ? a[0] : f(fold(f, a, m-1), a[m]);        
    }
}
