/**
 * Copyright (c) 2006, Regents of the University of California
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer.
 *
 * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * Neither the name of the University of California, Los Angeles nor the
 * names of its contributors may be used to endorse or promote products
 * derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Creation date: Feb 8, 2007
 */

package vpc.core.virgil;

/**
 * This class collects together the constants for all of the operators related
 * to the Virgil programming language.
 *
 * @author Ben L. Titzer
 */
public class VirgilOp {

    public static final int RAW_CONCAT = 40;
    public static final int RAW_GETBIT = 41;
    public static final int RAW_SETBIT = 42;

    public static final int TYPE_CAST = 43;
    public static final int TYPE_QUERY = 44;

    public static final int NULL_CHECK = 45;

    public static final int CLASS_GETFIELD = 46;
    public static final int CLASS_SETFIELD  = 47;
    public static final int CLASS_GETMETHOD = 48;

    public static final int COMPONENT_GETFIELD = 49;
    public static final int COMPONENT_SETFIELD  = 50;
    public static final int COMPONENT_GETMETHOD = 51;

    public static final int ARRAY_GETELEMENT = 52;
    public static final int ARRAY_SETELEMENT  = 53;
    public static final int ARRAY_GETLENGTH = 54;
    public static final int ARRAY_INIT = 55;
    public static final int DEVICE_GETREGISTER  = 56;
    public static final int DEVICE_SETREGISTER = 57;
    public static final int NEW_OBJECT = 58;
    public static final int NEW_ARRAY = 59;

}
